#ifndef   _MYTHOS_ALLOCATOR_H_
#define   _MYTHOS_ALLOCATOR_H_
#pragma    once

#define   _MALLOC_(ElemSize)            Malloc(ElemSize,1,__FILE__,__LINE__)

namespace Mythos
{
  class CClassID;
}

namespace Mythos
{
  class CAllocator
  {
  // public methods

  public:

    // raw memory
    
    virtual void*   Malloc              (const u32 u32ElemSize,const u32 u32Nb=1,const char* pszFile="",
                                         const u32 u32Line=0,const char* pszName="",const CClassID* pID=NULL) 
                                        { return new u8[u32ElemSize*u32Nb]; }
    virtual bool    Free                (void* pvAddr) { delete [] pvAddr; return true; }
    virtual void    FreeAll             (void) {}
  };
}

#endif // _MYTHOS_ALLOCATOR_H_
