//--------------------------------------------------------------------------------------------------------------------//
//                                                GLOBAL TYPEDEFS                                                     //
// 15/02/02, Mythos                                                                                                   //
//--------------------------------------------------------------------------------------------------------------------//

#ifndef   _MYTHOS_TYPEDEFS_H_
#define   _MYTHOS_TYPEDEFS_H_
#pragma    once

//----------------------------------------------- INCLUDES -----------------------------------------------------------//

#include  "Files/FileC.h"
#include  "Files/MemFileC.h"
//#include  "Files/DirC.h"
//#include  "Files/FindFileC.h"

#include  "Memory/MemC.h"
#include  "Memory/StringC.h"

//----------------------------------------------- TYPEDEFS -----------------------------------------------------------//

namespace Mythos
{
  typedef CFileC              File;
  typedef CMemFileC           MemFile;
//  typedef CDirC               Dir;
//  typedef CFindFileC          FindFile;

  typedef CMemC               Memory;
  typedef CStringC            String;
}

//--------------------------------------------------------------------------------------------------------------------//

#endif // _MYTHOS_TYPEDEFS_H_
