//--------------------------------------------------------------------------------------------------------------------//
//                                                MEMORY FUNCTIONS                                                    //
// 15/02/02, Mythos                                                                                                   //
//--------------------------------------------------------------------------------------------------------------------//

#ifndef   _MYTHOS_MEMC_H_
#define   _MYTHOS_MEMC_H_
#pragma    once

//----------------------------------------------- INCLUDES -----------------------------------------------------------//

#include  "Global/BasicTypes.h"
#include  "Global/Defines.h"

//----------------------------------------------- CLASSES ------------------------------------------------------------//

namespace Mythos
{
  class   CAllocator;
}

//--------------------------------------------------------------------------------------------------------------------//
//                                                CMemC                                                               //
//--------------------------------------------------------------------------------------------------------------------//

namespace Mythos
{
  class CMemC
  {
  // public methods

  public:

    static void*    MemSet              (void* pvDest,ui uiChr,u32 u32Count);
    static void*    MemCpy              (void* pvDest,const void* pvSrc,u32 u32Count);

    static void*    Malloc              (u32 u32Size, CAllocator* pAlloc);
    static bool     Free                (void* pvAddr,CAllocator* pAlloc);
  };
}

//----------------------------------------------- INLINES ------------------------------------------------------------//

#ifndef   _DEBUG
#include  "MemC.inl"
#endif

//--------------------------------------------------------------------------------------------------------------------//

#endif // _MYTHOS_MEMC_H_
