//--------------------------------------------------------------------------------------------------------------------//
//                                                STRING FUNCTIONS                                                    //
// 15/02/02, Mythos                                                                                                   //
//--------------------------------------------------------------------------------------------------------------------//

#ifndef   _MYTHOS_STRINGC_H_
#define   _MYTHOS_STRINGC_H_
#pragma    once

//----------------------------------------------- INCLUDES -----------------------------------------------------------//

#include  "Global/BasicTypes.h"
#include  "Global/Defines.h"

//----------------------------------------------- CLASSES ------------------------------------------------------------//

//--------------------------------------------------------------------------------------------------------------------//
//                                                CStringC                                                            //
//--------------------------------------------------------------------------------------------------------------------//

namespace Mythos
{
  class CStringC
  {
  // public methods

  public:

    static u32      StrLen              (const char* pszString);
    static char*    StrnCpy             (char* pszDest,const char* pszSrc,u32 u32Count);
    static char*    StrCat              (char* pszDest,const char* pszSrc);
    static char*    StrChr              (const char* pszString,u32 u32Chr);
    static char*    StrCpy              (char* pszDest,const char* pszSrc);
  };
}

//----------------------------------------------- INLINES ------------------------------------------------------------//

#ifndef   _DEBUG
#include  "StringC.inl"
#endif

//--------------------------------------------------------------------------------------------------------------------//

#endif // _MYTHOS_STRINGC_H_
